#!/usr/local/bin/python2.5
# TODO: order items before building html


### LOCAL VARIABLES - change these to suit your environment
outFile = "books.html"
feed = "http://www.goodreads.com/review/list_rss/1383164?shelf=favorites"
amazonID = u"subclassed-20"
fontPath = "lib/agencyb.ttf"
mainTplPath = "lib/booklist-template.tpl"
itemTplPath = "lib/book-template.tpl"

### BEGIN SCRIPT
import urllib2, sys, codecs
import xml.etree.ElementTree as etree
import Image, ImageDraw, ImageFont
from uuid import uuid4
from string import Template

def getVal(item, tag, escaped=False):
	elem = item.find(tag)
	val = u""
	if (type(elem) != type(None)) and (type(elem.text) != type(None)):
		val = elem.text.strip()
	else:
		return ""
	
	if escaped and type(val) == type("s"):
		return val.encode("utf-8","xmlcharrefreplace")
	elif type(val) == type("s"):
		return val.encode("utf-8")
	else:
		return val

opener = urllib2.build_opener()

f = opener.open(feed)
tree = etree.parse(f)
items = tree.findall("//item")

# load main template
fTplMain = codecs.open(mainTplPath,"rb", "utf-8")
tplMain = Template(fTplMain.read())

# load single-book template
fTplItem = codecs.open(itemTplPath,"rb", "utf-8")
tplItem = Template(fTplItem.read())

bgcolor =(150, 199, 125) # bg color 
fontcolor = (255,255,153) # fg color
font = ImageFont.truetype(fontPath,20)

itemStrList = ""
for item in items:
	# build amazon link
	amazonlink = u"http://www.amazon.com/exec/obidos/ASIN/" + getVal(item,"isbn") + u"/tag=" + amazonID
	
	# build image for book title
	title = getVal(item,"title")
	imgSize = font.getsize(title)
	imgTitle = Image.new('RGB',imgSize,bgcolor)
	drawTitle = ImageDraw.Draw(imgTitle)
	drawTitle.text((0,0),title,font=font,fill=fontcolor)
	imgname = "static/booktitles/" + uuid4().hex + ".png"
	imgTitle.save(imgname)
	imgTitle = None
	drawTitle = None
	
	# put all in mapping dict
	mapping = {
		'amazonURL':amazonlink,
		'title':getVal(item,"title",True),
		'imgpath':getVal(item,"book_small_image_url"),
		'imgtitlepath':imgname,
		'review':getVal(item,"user_review",True),
		'author':getVal(item,"author_name",True),
		'goodreadsURL':u"http://www.goodreads.com/book/show/" + getVal(item,"book_id")
		}
	# concat
	itemStrList += tplItem.safe_substitute(mapping)

targetUStr = tplMain.safe_substitute({'booklist':itemStrList})

target = codecs.open(outFile,"wb", "utf-8")
target.write(targetUStr)
target.close()
print "Done!"

	
